function [Net, Err_Appr, Err_Test, Cur_iter, Yac, Ytc, ErrorMimimum, BestNet] = mlpLearn ( ...
     Net, Xa, Ya, Xt, Yt, n_cycles, cycles_before_test, seuil_arret, algorithm)
global options Nb_Iter foptions
if nargin ~= 9 | nargout ~= 6 + 2 % I added 2 new nargouts, ErrorMimimum and BestNet,
                                  % I could have use $Net to return $BestNet though, and 
                                  % $ErrorMimimum isn't actually needed in
                                  % SpotLearning.m ...
    error(sprintf(['\n'...
             '-------------------- Appel de mlp_learn ------------------- \n\n' ...
            '[Net, Err_Appr, Err_Test, Cur_iter, Yac, Ytc] = mlp_learn (Net, Xapp, Yapp,\n'...
            '         Xtest, Ytest, nbre_iterations, nbre_iter_avant_test,\n' ...
            '         seuil_arret, algorithm);\n' ...
            '----------------------------------------------------------']));
end
options     = zeros(1,18);
options(1)  = 1;               
options(2)  = seuil_arret;
options(3)  = seuil_arret;
Nb_Iter = 0:cycles_before_test:n_cycles;
if Nb_Iter(end) ~= n_cycles
   Nb_Iter = [Nb_Iter, n_cycles];
end
plotvals = [0:0.01:1]';
%calcul de l'erreur entre entre Ya et Yac (calcul par le rseau)
Yac = mlpfwd(Net, Xa); 
err_a = sqrt(sum(sum((Ya - Yac) .^ 2)) / size(Xa,1));
Err_Appr = [ err_a ];
%calcul de l'erreur entre entre Yt et Ytc (calcul par le rseau)
Ytc = mlpfwd(Net, Xt); 
err_t = sqrt(sum(sum((Yt - Ytc) .^ 2)) / size(Xt,1));
Err_Test = [ err_t ];
Cur_iter = [ Nb_Iter(1) ];
last_cycle = 0;

%We want to save the best weights!
ErrorMimimum = 1000;
BestNet = Net;

for i_iter = 2:length(Nb_Iter)
	% Nombre maximum de cycles d'apprentissage.
        options(14) = Nb_Iter(i_iter) - Nb_Iter(i_iter-1);
	% Cycle d'apprentissage
        foptions=options;
	[Net, options] = netopt(Net, options, Xa, Ya, algorithm);  
	% Calcul de l'erreur
        Yac = mlpfwd(Net, Xa); 
        err_a = sqrt(sum(sum((Ya - Yac) .^ 2)) / size(Xa,1));
        Err_Appr = [Err_Appr, err_a];
        Ytc = mlpfwd(Net, Xt); 
        err_t = sqrt(sum(sum((Yt - Ytc) .^ 2)) / size(Xt,1));
        
        %We want to save the best weights!
        if err_t < ErrorMimimum
            ErrorMimimum = err_t;
            BestNet = Net;
        end
        
	Err_Test = [Err_Test, err_t];
        %
	Cur_iter = [Cur_iter, Nb_Iter(i_iter)];
        % disp(['--> RMS_apprentissage = ' num2str(err_a) ', RMS_test = ' num2str(err_t) ])		CHANGED: commented
	semilogy(Cur_iter,Err_Appr,'b-',Cur_iter,Err_Test,'r-',Cur_iter,Err_Appr,'bo',Cur_iter,Err_Test,'r+')
	ylabel('RMS error'), xlabel('nb. de cycles')
	if (options(10) - last_cycle) < options(14) 
	   break % convergence par seuil
	end
	drawnow
	last_cycle = options(10);
end
[min_err_t, i_min_err_t] = min(Err_Test);
msg = ['Erreur Minimum de Test = ' num2str(min_err_t(1))];
xlabel(msg);
% disp([ ' ====> ' msg ]); CHANGED: commented
ymin=ones(1,options(10))*min_err_t;
hold on
plot(ymin,'g-')
return
