function [] = mlpWrapper (input, output, Predict_size, DApp_size, DVal_size, DTest_size )


Xapp=input(1:DApp_size,:); 
Yapp=output(1:DApp_size,:);
XVal=input(DApp_size + 1:DApp_size + DVal_size,:); 
YVal=output(DApp_size + 1:DApp_size + DVal_size,:); 
XTest=input(DApp_size + DVal_size + 1:DApp_size + DVal_size + DTest_size - Predict_size,:);  
YTest=output(DApp_size + DVal_size + 1:DApp_size + DVal_size + DTest_size - Predict_size,:);  


% Nous allons faire varier le nombre de neurones cachs entre $MinNhidden
% et $MaxNhidden :  chaque itration, nous ferons apprendre le rseau et
% calculerons l'ARV pour le rseau ayant une erreur de test minimal

nhiddenSet = [48]; % 1,3,6,12, 24, 48, 48*2, 48*3
MinNhidden = min(nhiddenSet);
MaxNhidden = max(nhiddenSet);

MLPDisplayGraph = true ; % Set to true if you want to display all figures
                         % Set to false if you don't want to display all
                         %   figures, which is strongly advised nhiddenSet
                         %   and/or Predict_size sets have a high cardinal.

for nhidden = nhiddenSet 
    if not(MLPDisplayGraph); 
        warning off; 
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Learning
    nin = size(input,2);   % Le nombre de neurones d'entres correspond  la taille des vecteurs entrs
    nout = size(output,2); % Le nombre de neurones de sortie correspond  la taille des vecteurs rsultats
    outfunc = 'linear';   % outfunc : fonction d'activation pour la couche de sortie (= 'linear', 'logistic' ou 'softmax')
    Net = mlp(nin, nhidden, nout, outfunc); % Cration du rseau de neurones

    % Paramtres pour arrter l'apprentissage et viter le sur-apprentissage
    % grce  l'early stopping.
    NbreIterations=200;
    NbreIterAvantTest=10;
    SeuilArret = 0.0001;

    algorithm = 'scg'; % It determines which optimization algorithm (CONJGRAD, QUASINEW, SCG,
                       % etc.) or Monte Carlo algorithm (such as HMC) will be used when learning:
                       % 'conjgrad' = Conjugate gradients optimization
                       % 'quasinew' = Quasi-Newton optimization.
                       % 'scg' = Scaled Conjugate Gradient optimization
                       %  ...
     % On cre un nouveau graphique pour chaque itration, sinon les courbes
     % vont se superposer et le graphique ne sera pas visible.               
    if MLPDisplayGraph; 
        figure
    end; 
    set(gca,'YScale','log')
    

    randn('state', 2);  % Random seeding to get the same results all the time

    % Apprentissage du rseau.
    [Net, ErrAppr, ErrTest, CurIter, Yac, Ytc, ErrorMimimum, BestNet] = mlpLearn ( ...
    Net, Xapp, Yapp, XVal, YVal, ...
    NbreIterations, NbreIterAvantTest, SeuilArret, algorithm);

    % Paramtres du graphique.
    grid on;
    legend(': Taux d''erreur d''apprentissage',': Taux d''erreur test')
    title('Learning')
    
    % Graphically compare expected values with the values predicted by our model.
    if MLPDisplayGraph; 
        figure
    end;
    Ycalculee=mlpfwd(Net,input);
    X = 1953+(Predict_size*1/48):1/48:1983-1/48; % We take 48 since we have 48 values for each year
    plot(X,output,'b',X,Ycalculee,'r')
    legend(': Y dsir',': Y calcul');

    % Display minimum test error
    [min_err_t, i_min_err_t] = min(ErrTest);
    msg = ['Erreur Minimum de Test = ' num2str(min_err_t(1)) ' avec ' num2str(nhidden) ' neuronnes caches'];
    xlabel(msg);
    disp([ ' ====> ' msg ]);

    % Computing ARV
    YTestCalc = mlpfwd(BestNet, XTest);
    save YTestCalc;
    numerator = ((sum((YTest - YTestCalc) .^2)) / size(YTest,1));
    denominator = ((sum((output - mean(output)) .^2)) / size(output,1));
    ARV(nhidden, :) = numerator / denominator;
    
    % Save BestNet
    BestNets(nhidden,:) = BestNet;

end

save('Net.mat', 'Net');

% The Average Relative Variance evaluates the relationship
% of the model with the other model, which proposes that the
% time series future value is equal to the arithmetic mean of
% the past values. 
% When ARV is equal to one, the proposed model is equivalent
% to the mean of past values. If ARV is lower than one,
% then the proposed model is better than the mean of past
% values. If the ARV is greater than one, the proposed model
% has a performance worse than mean of past values.

% Display ARVs
fprintf('\n\n ==============================');
fprintf('\n  === ARV table with DTest ===');
fprintf('\n ==============================\n');
for nhidden = nhiddenSet
    fprintf('ARV with %d hidden neurons = %d\n', nhidden, ARV(nhidden,:));
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Best net's weights:
% [Y,I] = min(ARV(MinNhidden:MaxNhidden)); % On prend le rseau dont l'ARV est
                                         % la meilleure, c'est--dire minimale.

% fprintf('\n\n ============================');
% fprintf('\n  === Best net''s weights ===');
% fprintf('\n ============================\n');
% fprintf('First-layer weight matrix: \n');
% disp(BestNets(I + MinNhidden - 1,:).w1)
% fprintf('Second-layer weight matrix: \n');
% disp(BestNets(I + MinNhidden - 1,:).w2)

return